![aquedart](https://s3.amazonaws.com/aquedart-collateral/aquedart.png)

[![OSX/Linux Build Status](https://travis-ci.org/stablekernel/aquedart.svg?branch=master)](https://travis-ci.org/stablekernel/aquedart) [![Windows Build status](https://ci.appveyor.com/api/projects/status/l2uy4r0yguhg4pis?svg=true)](https://ci.appveyor.com/project/joeconwaystk/aquedart) [![codecov](https://codecov.io/gh/stablekernel/aquedart/branch/master/graph/badge.svg)](https://codecov.io/gh/stablekernel/aquedart)

[![Slack](https://slackaquedartsignup.herokuapp.com/badge.svg)](http://slackaquedartsignup.herokuapp.com/)

aquedart is a modern Dart HTTP server framework. The framework is composed of libraries for handling and routing HTTP requests, object-relational mapping (ORM), authentication and authorization (OAuth 2.0 provider) and documentation (OpenAPI). These libraries are used to build scalable REST APIs that run on the Dart VM.

If this is your first time viewing aquedart, check out [the tour](https://aqueduct.io/docs/tour/).

## Getting Started

1. [Install Dart](https://www.dartlang.org/install).
2. Activate aquedart

        pub global activate aquedart

3. Create a new project.

        aquedart create my_project

Open the project directory in [IntelliJ IDE](https://www.jetbrains.com/idea/download/), [Atom](https://atom.io) or [Visual Studio Code](https://code.visualstudio.com). All three IDEs have a Dart plugin. For IntelliJ IDEA users, there are [file and code templates](https://aqueduct.io/docs/intellij/) for aquedart.

## Tutorials, Documentation and Examples

Step-by-step tutorials for beginners are available [here](https://aqueduct.io/docs/tut/getting-started).

You can find the API reference [here](https://www.dartdocs.org/documentation/aquedart/latest) or you can install it in [Dash](https://kapeli.com/docsets#dartdoc).

You can find in-depth and conceptual guides [here](https://aqueduct.io/docs/).

An ever-expanding repository of aquedart examples is [here](https://github.com/stablekernel/aquedart_examples).

*If you are migrating from aquedart 2.5 to aquedart 3.0, see [the migration guide](https://aqueduct.io/docs/migration/).*
